
\chapter{Ontologies Representation}

\section{Somewhere's view of what is an ontology}
Each Somewhere peer contains, through its logic module (it could be 
the {\bf plogic} module supplied, or another), ontologies datas, called
{\em propositional instances}. \\
Each {\em propositional instances} contains :
\begin{description}
	\item[Theory] Ontologies written with propositional logic clauses.
		This is the local part of the propositional instance, as
		each literal are those of the local peer.
	\item[Mapping] Ontologies like the theory, but with literals that can
		be others peers's literals.
	\item[Production variables] Production set of {\em interresting} local
		variables, used for computation of Consequence Finding algorithms.
\end{description}


\section{Files Formats}
Somewhere can import the knowledge base (the peer profile) from two kind of files:
\begin{description}
	\item[\verb!.swr! files] This is the instances format of the original 
		Somewhere (Somewhere-Adjiman). \\
		In this format, there are information about how to physically access to one
		peer (hostname and port). This information is ignored.
	\item[\verb!.xml! files] This is the instances format of the
		SomewherePlusJXTA (Niraula's) Somewhere version. \\
		Everything in this format is used in {\bf Somewhere 2.0}. \\
		You can see the XSD schema of this format in the appendix. % TODO : add ref
\end{description}


\subsection{Example of a {\bf .swr} instance file}

Peer P1:
\begin{lstlisting}
s1.inria.fr:50000:P1
s1.inria.fr:50000:P1:A1 s1.inria.fr:50000:P1:B1
!s1.inria.fr:50000:P1:A2 s1.inria.fr:50000:P1:B1 s1.inria.fr:50000:P1:B3
s1.inria.fr:50000:P1:B1 !s1.inria.fr:50000:P1:A6 !s1.inria.fr:50000:P1:B3
s1.inria.fr:50000:P1:B3 !s1.inria.fr:50000:P1:B2
!s1.inria.fr:50000:P1:B3 s1.inria.fr:50000:P1:B2
Mappings
!s1.inria.fr:50000:P1:B2 !s2.inria.fr:50000:P2:D1 !s2.inria.fr:50000:P2:C1
s2.inria.fr:50000:P2:D1 !s1.inria.fr:50000:P1:A2
!s1.inria.fr:50000:P1:A2 s2.inria.fr:50000:P2:D1
Production
s1.inria.fr:50000:P1:A1 s1.inria.fr:50000:P1:B1
s1.inria.fr:50000:P1:B3
\end{lstlisting}

Peer P2:
\begin{lstlisting}
s2.inria.fr:50000:P2
s2.inria.fr:50000:P2:D1 !s2.inria.fr:50000:P2:D2 !s2.inria.fr:50000:P2:C2
!s2.inria.fr:50000:P2:D1 s2.inria.fr:50000:P2:C2
s2.inria.fr:50000:P2:C1 s2.inria.fr:50000:P2:D1
!s2.inria.fr:50000:P2:C1 !s2.inria.fr:50000:P2:C2
s2.inria.fr:50000:P2:C1 !s2.inria.fr:50000:P2:C3 !s2.inria.fr:50000:P2:D2
Mappings
s2.inria.fr:50000:P2:D2 s1.inria.fr:50000:P1:B2 s2.inria.fr:50000:P2:C1
s2.inria.fr:50000:P2:C1 !s1.inria.fr:50000:P1:A2
!s1.inria.fr:50000:P1:A2 s2.inria.fr:50000:P2:C1 s2.inria.fr:50000:P2:D2
Production
s2.inria.fr:50000:P2:C1 s2.inria.fr:50000:P2:D1
\end{lstlisting}

You can see others examples in the Somewhere-Adjiman documentation.


\subsection{Example of a {\bf .xml} instance file}

Peer P1:
\begin{lstlisting}[language=xml]
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE peer SYSTEM "PeerProfile.xsd">
<peer>
	<uri>s1.inria.fr</uri>
	<theory>

		<clause>
			<literal>
				<variable>A1</variable>
				<variable>B1</variable>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable>A2</variable></not>
				<variable>B1</variable>
				<variable>B3</variable>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable>B1</variable>
				<variable>A6</variable>
				<not><variable>B3</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable>B3</variable>
				<not><variable>B2</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable>B3</variable></not>
				<variable>B2</variable>
			</literal>
		</clause>

	</theory>


	<mapping>

		<clause>
			<literal>
				<not><variable url="s1.inria.fr:P1">B2</variable></not>
				<not><variable url="s2.inria.fr:P2">D1</variable></not>
				<not><variable url="s2.inria.fr:P2">C1</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable url="s2.inria.fr:P2">D1</variable>
				<not><variable url="s1.inria.fr:P1">A2</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable url="s1.inria.fr:P1">A2</variable></not>
				<variable url="s2.inria.fr:P2">D1</variable>
			</literal>
		</clause>

	</mapping>

	<production>
		<variable>A1</variable>
		<variable>B1</variable>
		<variable>B3</variable>
	</production>

</peer>

\end{lstlisting}

Peer P2:
\begin{lstlisting}
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE peer SYSTEM "PeerProfile.xsd">
<peer>
	<uri>s2.inria.fr</uri>
	<theory>

		<clause>
			<literal>
				<variable>D1</variable>
				<not><variable>D2</variable></not>
				<not><variable>C2</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable>D1</variable></not>
				<variable>C2</variable>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable>C1</variable>
				<variable>D1</variable>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable>C1</variable></not>
				<not><variable>C2</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable>C1</variable>
				<not><variable>C3</variable></not>
				<not><variable>D2</variable></not>
			</literal>
		</clause>

	</theory>


	<mapping>

		<clause>
			<literal>
				<variable url="s2.inria.fr:P2">D2</variable>
				<variable url="s1.inria.fr:P1">B2</variable>
				<variable url="s2.inria.fr:P2">C1</variable>
			</literal>
		</clause>

		<clause>
			<literal>
				<variable url="s2.inria.fr:P2">C1</variable>
				<not><variable url="s1.inria.fr:P1">A2</variable></not>
			</literal>
		</clause>

		<clause>
			<literal>
				<not><variable url="s1.inria.fr:P1">A2</variable></not>
				<variable url="s2.inria.fr:P2">C1</variable>
				<variable url="s2.inria.fr:P2">D2</variable>
			</literal>
		</clause>

	</mapping>

	<production>
		<variable>C1</variable>
		<variable>D1</variable>
	</production>

</peer>

\end{lstlisting}

You can see others examples in the SomewherePlusJXTA documentation.

